type 'a t = {
  mutable stack : 'a list;
  mutable size : int;
}

let empty () = { stack = []; size = 0 }

let push s v =
  s.stack <- v :: s.stack;
  s.size <- s.size + 1

let pop s =
  match s.stack with
  | [] -> failwith "Fifo.pop"
  | v :: l ->
      s.stack <- l;
      s.size <- s.size - 1;
      v

let peek s =
  match s.stack with
  | [] -> failwith "Fifo.peek"
  | v :: _ -> v

let size s = s.size
let iter f s = List.iter f s.stack
