open Tree

module Test (Col : Defn.S) =
struct

  let test () =
    let c = Col.empty () in
    for i = 0 to 9 do
      Col.push c i;
    done;
    assert (Col.size c = 10);
    while Col.size c > 0 do
      let v = Col.pop c in
      Printf.printf "%d\n" v;
    done;
    Printf.printf "----\n"
end

module T1 = Test(Fifo)
let () = T1.test ()

module T2 = Test(Lifo)
let () = T2.test ()



let tree =
  Node
    ( Node (Node (Leaf, "A", Leaf), "B", Node (Leaf, "C", Leaf)),
      "D",
      Node (Node (Leaf, "E", Leaf), "F", Node (Leaf, "G", Leaf)) )
let () = Printf.printf "LEFTMOST: %s\n" (left_most tree)

module Dfs = Iter(Fifo)
module Bfs = Iter(Lifo)

(* Parcours prefixe, en profondeur d'abord *)
let () = Dfs.iter (Printf.printf "%s\n") tree
let () = Printf.printf "-----\n"
(* Parcours en largeur de la droite vers la gauche *)
let () = Bfs.iter (Printf.printf "%s\n") tree
